{$A-,B-,E+,N+,G+,I-,S+,V-,T-,P-,X+,D+,L+,R+}

{$IFDEF DPMI}
{$M 65520}
{$ELSE}
{$M 65520,32768,655360}
{$F+,O+}
{$ENDIF}

                 {Copyright Gheorghe Tihenea 1994}

program colTest;

USES Objects, Dialogs, Drivers, Views, Menus, App, Dos, Gadgets, GenHlp;

CONST cmTst1 = 100;
      cmTst2 = 101;

TYPE TMyApp = object(TApplication)
       Clock: PClockView;
       Heap : PHeapView;
       CONSTRUCTOR Init;
       PROCEDURE HandleEvent(var Event: TEvent); virtual;
       PROCEDURE InitMenuBar; virtual;
       PROCEDURE InitStatusLine; virtual;
       PROCEDURE Idle; virtual;
     end;

FUNCTION filesCol: PHlpCollection; far;
{Creates a collection of files in current directory}
VAR ViewList: PHlpCollection; {a collection}
           k: Char;
           S: SearchRec;

   FUNCTION NewHlpEntry(DispText, onLine: string; UserDef: SearchRec):
                                                            PCollEntry; near;
   VAR HlpEntry: PCollEntry;
           myCh: ^SearchRec;
   begin
     New(HlpEntry);    FillChar(HlpEntry^,SizeOf(TCollEntry),#0);
     with HlpEntry^ do
       begin
         DisplayText := NewStr(DispText);   lineText := NewStr(onLine);
         New(myCh);  myCh^ := UserDef;   UserVal := myCh;
         UserSize := SizeOf(myCh^);   isTagged := FALSE;
       end;
     NewHlpEntry := HlpEntry;
   end; {NewHlpEntry}




begin
  ViewList := New(PHlpCollection, Init(50,5)); {create the collection}
  FindFirst('*.*',ARCHIVE, S);
  while DosError = 0 do
    begin
      if (S.Attr AND DOS.Directory = 0) then ViewList^.Insert(
              NewHlpEntry(' ' + S.Name,copy(S.Name,1,pred(pos('.',S.Name))),S));
      FindNext(S);
    end;
  ViewList^.SetLimit(ViewList^.Count);   filesCol := ViewList;
end; {filesCol}




FUNCTION drvCol: PHlpCollection; far;
{Creates a collection of drives}
VAR ViewList: PHlpCollection;
           k: Char;
           S: SearchRec;

   FUNCTION NewHlpEntry(DispText, onLine: string; UserDef: Char):
                                                            PCollEntry; near;
   VAR HlpEntry: PCollEntry;
           myCh: ^Char;
   begin
     New(HlpEntry);    FillChar(HlpEntry^,SizeOf(TCollEntry),#0);
     with HlpEntry^ do
       begin
         DisplayText := NewStr(DispText);   lineText := NewStr(onLine);
         New(myCh);   myCh^ := UserDef;   UserVal := myCh;
         UserSize := SizeOf(myCh^);
         isTagged := FALSE;
       end;
     NewHlpEntry := HlpEntry;
   end; {NewHlpEntry}




   FUNCTION DriveValid(Drive: Char): Boolean; assembler;
   asm
          MOV  DL, Drive
          MOV  AH, 36H
          SUB  DL, 'A' - 1
          INT  21H
          INC  AX
          JE   @@2
     @@1: MOV  AL, 1
     @@2:
   end; {DriveValid}



begin
  ViewList := New(PHlpCollection, Init(50,5));   k := 'C';
  ViewList^.Insert(NewHlpEntry('A:\','A:\','A'));
  ViewList^.Insert(NewHlpEntry('B:\','B:\','B'));
  while DriveValid(k) AND (k < 'Z') do
    begin
      if DriveValid(k) then ViewList^.
                                    Insert(NewHlpEntry(k + ':\',k + ':\',k));
      k := succ(k);
    end;
  ViewList^.SetLimit(ViewList^.Count);   drvCol := ViewList;
end; {drvCol}



{ TMyApp }
PROCEDURE TMyApp.HandleEvent(var Event: TEvent);

      PROCEDURE test1;
      {this test shows how to attach a collection to an input line to make a
       pickup list(drop down) !
       NOTE: Very importat ! the collections are not created when they are
             inserted, they WILL BE created only if the icon is selected.
             This let you attach many collections to input lines without
             having them taking memory for as long long as your dialog
             exists. This in turn makes practical implementing pick up
             lists associated with input lines !}
      VAR locDiag: PDialog;
       Vali,Vali1: PHlpView;
                R: TRect;
          control: word;
       PartInput,
       PartInput1: PInputLine;
        oneC,secC: HlpRecType;
              res: TCollEntry;
      begin
        R.Assign(1, 1, 36, 15);
        locDiag := new(PDialog, Init(R, 'Test'));
        if locDiag <> NIL then with locDiag^ do
          begin
            Options := Options OR ofCentered;

            with oneC,HlpRec do {init the collection 'oneC'}
              begin
                aCollList := NIL;   aListPos := 0;
                allowToggle := FALSE;{when attach a collection to an input
                line the value of 'allowToggle' will be reset internaly to
                FALSE; I saw no point in multiple selects from a drop down
                list !}
                aCollFunc := filesCol; {set 'aCollFunc' to point to
                'filesCol' function. The colection in not created here !}
              end;

            R.Assign(2, 2, 15, 3);
            PartInput := New(PInputLine,Init(R,79));
            Insert(PartInput);

            {use 'PHlpView' to attach 'oneC' to PartInput input line; Again,
             the collection is not created at this time}
            R.Assign(17, 2, 20, 3);
            Vali := New(PHlpView, Init(R,oneC,'Test',PartInput));
            Insert(Vali);

            {same as above for 'secC'}
            with secC,HlpRec do
              begin
                aCollList := NIL;   aListPos := 0;   allowToggle := FALSE;
                aCollFunc := drvCol;
              end;

            R.Assign(2, 4, 15, 5);
            PartInput1 := New(PInputLine,Init(R,79));
            Insert(PartInput1);

            R.Assign(17, 4, 20, 5);
            Vali1 := New(PHlpView, Init(R,secC,'Test',PartInput1));
            Insert(Vali1);

            R.Assign(Size.X - 12, Size.Y - 3, Size.X - 2, Size.Y - 1);
            Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

            R.Assign(2, Size.Y - 3, 12, Size.Y - 1);
            Insert(New(PButton, Init(R, 'O~K~', cmOK, bfDefault)));

            SelectNext(FALSE);

            {now we execute the dialog... if the icon for attached pickup
             list is pressed, then at that moment the collection is created}
            control := DeskTop^.ExecView(locDiag);
            if control <> cmCancel then
              begin
                Vali^.GetCollElement(res);  {get the result for first line..}
                {just for verify put it on the screen ! not to be done this
                way in ANY TV program !!!!}
                if res.DisplayText <> NIL then write(res.DisplayText^,'  ');
                if res.lineText <> NIL then write(res.lineText^,' ');
                if res.UserSize > 0 then write(SearchRec(res.UserVal^).Attr);
                writeln;

                Vali1^.GetCollElement(res);   {get the result from next line}
                if res.DisplayText <> NIL then
                                writeln(res.DisplayText^,'  ',res.lineText^);
              end;
            Dispose(locDiag, Done);
          end;
      end; {test1}



      PROCEDURE test2;
      {this second test show how to create and use a collection. If
       'allowToggle' is set to TRUE, then you can toggle on/off ellements of
       the collection with <space bar> or double click from the mouse. All
       ellements in collection can be toggled on with <Ctrl Space>, or
       toggled of with <Alt Space> or <Shift Space>}
      VAR       D: PGlobalHlp;
                R: TRect;
          wHlpRec: HlpRecType;
          locDiag: PDialog;
          control: word;

         PROCEDURE doShow(C: PCollection);

            PROCEDURE doTag(P: PCollEntry); far;
            begin
              with P^ do if isTagged then writeLn(DisplayText^);
            end; {doTag}



         begin
           C^.ForEach(@doTag);
         end; {doShow}



      begin
        R.Assign(1, 1, 60, 20);
        locDiag := new(PDialog, Init(R, 'Test'));
        if locDiag <> NIL then with locDiag^ do
          begin
            Options := Options OR ofCentered;

            with wHlpRec,HlpRec do
              begin
                aCollList := NIL;   aListPos := 0;   allowToggle := TRUE;
                aCollFunc := filesCol;
              end;

            R.Assign(2, 1, 56, 15);
            D := New(PGlobalHlp,Init(R,3,FALSE,
                          StandardScrollBar(sbVertical + sbHandleKeyboard)));
            insert(D); {insert the collection in diag box}
            D^.SetData(wHlpRec); {CREATE THE COLLECTION !!!}

            R.Assign(Size.X - 12, Size.Y - 3, Size.X - 2, Size.Y - 1);
            Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

            R.Assign(2, Size.Y - 3, 12, Size.Y - 1);
            Insert(New(PButton, Init(R, 'O~K~', cmOK, bfDefault)));

            SelectNext(FALSE);

            control := DeskTop^.ExecView(locDiag);
            if control <> cmCancel then
              begin
                D^.GetData(wHlpRec);  {get result...}
                {...and display it !!! This is no TV but... is fast !}
                with wHlpRec,HlpRec do
                  begin
                    write(PCollEntry(aCollList^.At(aListPos))^.DisplayText^,
                                                    ' pos in col ',aListPos);
                    writeln;
                    if allowToggle then doShow(aCollList)
                  end;
              end;
            Dispose(locDiag, Done);
          end;
      end; {test2}



begin
  TApplication.HandleEvent(Event);
  if Event.What = evCommand then
    case Event.Command of
      cmTst1: Test1;
      cmTst2: Test2;
    end;
    ClearEvent(Event);
end;



PROCEDURE TMyApp.Idle;
begin
  TApplication.Idle;
  Clock^.Update;   Heap^.Update;
end; {TMyApp.Idle}



CONSTRUCTOR TMyApp.Init;
VAR R: TRect;
    H: Word;
begin
  TApplication.Init;
  GetExtent(R);
  R.A.X := R.B.X - 9; R.B.Y := R.A.Y + 1;
  Clock := New(PClockView, Init(R));
  Insert(Clock);

  GetExtent(R);
  R.A.X := R.B.X - 9; R.A.Y := R.B.Y - 1;
  Heap := New(PHeapView, Init(R));
  Insert(Heap);
end; {TMyApp.Init}



PROCEDURE TMyApp.InitMenuBar;
var R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~T~ests', hcNoContext, NewMenu(
      NewItem('~T~est1', 'F3', kbF3, cmTst1, hcNoContext,
      NewItem('~T~est2', 'F4', kbF4, cmTst2, hcNoContext,
      NewLine(
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil))))),
    nil)
  )));
end;



PROCEDURE TMyApp.InitStatusLine;
var R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(PStatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('', kbF10, cmMenu,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      nil)),
    nil)
  ));
end;



VAR MyApp: TMyApp;
begin
  MyApp.Init;
  MyApp.Run;
  MyApp.Done;
end.
